$().ready(function () {
	$('#loadOldMessages').on('click', function (e) {
		var offset = parseInt($(this).attr('data-offset'));
		var new_offset = offset + $.pagination_size;
		var channel_name = $('#sendMessageButton').attr('data-channel-name');
	    var current_userinfo = jQuery.parseJSON(localStorage["userinfo"]);
	    var current_user_id  = current_userinfo.user_info.user_id;
		$(this).attr('data-offset', new_offset);

	    var messages = getPaginatedMessagesFromDB(channel_name,new_offset, $.pagination_size);
	    plotPaginatedMessagesFromDB(messages, current_user_id, channel_name, "#msgReader", "p2p", new_offset)
        // hide pagination bar if messages are not available.
        if (messages.length < $.pagination_size) {
            $('#loadOldMessages').hide();
            $('#loadOldMessagesPlaceHolder').hide();
            //fix pagination height issue for p2p
            $('#msgReader').css('height', $(window).height() - (52 + $('.headerPan').height()));
        };
	});

	$('#loadOldMessagesForGroup').on('click', function (e) {
		var offset = parseInt($(this).attr('data-offset'));
		var new_offset = offset + $.pagination_size;
		var channel_name = $('#sendGroupMessageButton').attr('data-channel-name');
		var chat_type = $('#sendGroupMessageButton').attr('data-chat-type');
	    var current_userinfo = jQuery.parseJSON(localStorage["userinfo"]);
	    var current_user_id  = current_userinfo.user_info.user_id;
		$(this).attr('data-offset', new_offset);

	    var messages = getPaginatedMessagesFromDB(channel_name,  new_offset, $.pagination_size);//function(messages){
	    plotPaginatedMessagesFromDB(messages, current_user_id, channel_name, "#groupMsgReader", chat_type, new_offset)
        // hide pagination bar if messages are not available.
        if (messages.length < $.pagination_size) {
            $('#loadOldMessagesForGroup').hide();
            $('#loadOldMessagesForGroupPlaceHolder').hide();
            //fix pagination height issue for group and role
            $('#groupMsgReader').css('height', $(window).height() - (52 + $('.headerPan').height()));
        };
	});
});

function nullHandler() {}

function errorHandler() { alert('error'); }


function resetTime(){
    $.datetimeofpreviousmessage = '' // reset previous time
}
// get pagibnated data to reduce query load on memory
function getPaginatedMessagesFromDB(channel_name,  offset, limit){
    
	var messages = [];
        var resultSet = db.execute('SELECT * FROM socialfire where socialfire.channel_name=? order by socialfire.id DESC LIMIT ?, ?;', channel_name, offset, limit);
                    while (resultSet.isValidRow()) {
                        var msg_obj;
                            if (resultSet.fieldByName('attachment_type').toString() == "1") {
                                msg_obj = {
                                    "sender": {
                                        "id": resultSet.fieldByName('sender_id'),
                                        "name": resultSet.fieldByName('sender_name'),
                                        "photo": resultSet.fieldByName('sender_photo')
                                    },
                                    "receiver": {
                                        "id": resultSet.fieldByName('receiver_id'),
                                        "name": resultSet.fieldByName('receiver_name'),
                                        "photo": resultSet.fieldByName('receiver_photo')
                                    },
                                    "message_id": resultSet.fieldByName('message_id'),
                                    "channel_name": resultSet.fieldByName('channel_name'),
                                    "message": resultSet.fieldByName('message'),
                                    "date": resultSet.fieldByName('date'),
                                    "message_client_id": resultSet.fieldByName('message_client_id'),
                                    "time": resultSet.fieldByName('time'),
                                    "merge_to_last_message": resultSet.fieldByName('merge_to_last_message'),
                                    "textformat": resultSet.fieldByName('textformat'),
                                    "allowed_suborg_ids": resultSet.fieldByName('allowed_suborg_ids'),
                                    "group": {
                                        "id": resultSet.fieldByName('group_id'),
                                        "name": resultSet.fieldByName('group_name')
                                    },
                                    "role": {
                                        "id": resultSet.fieldByName('role_id'),
                                        "name": resultSet.fieldByName('role_name')
                                    },
                                    "like_count": resultSet.fieldByName('like_count'),
                                    "like_status": resultSet.fieldByName('like_status'),
                                    "is_liking": resultSet.fieldByName('is_liking')
                                }
                            } else {
                                msg_obj = {
                                    "sender": {
                                        "id": resultSet.fieldByName('sender_id'),
                                        "name": resultSet.fieldByName('sender_name'),
                                        "photo": resultSet.fieldByName('sender_photo')
                                    },
                                    "receiver": {
                                        "id": resultSet.fieldByName('receiver_id'),
                                        "name": resultSet.fieldByName('receiver_name'),
                                        "photo": resultSet.fieldByName('receiver_photo')
                                    },
                                    "message_id": resultSet.fieldByName('message_id'),
                                    "channel_name": resultSet.fieldByName('channel_name'),
                                    "message": resultSet.fieldByName('message'),
                                    "date": resultSet.fieldByName('date'),
                                    "message_client_id": resultSet.fieldByName('message_client_id'),
                                    "time": resultSet.fieldByName('time'),
                                    "merge_to_last_message": resultSet.fieldByName('merge_to_last_message'),
                                    "textformat": resultSet.fieldByName('textformat'),
                                    "attachment_type": resultSet.fieldByName('attachment_type'),
                                    "attachment_url": resultSet.fieldByName('attachment_url'),
                                    "channel_event": "message",
                                    "video_image": resultSet.fieldByName('video_image'),
                                    "allowed_suborg_ids": resultSet.fieldByName('allowed_suborg_ids'),
                                    "group": {
                                        "id": resultSet.fieldByName('group_id'),
                                        "name": resultSet.fieldByName('group_name')
                                    },
                                    "role": {
                                        "id": resultSet.fieldByName('role_id'),
                                        "name": resultSet.fieldByName('role_name')
                                    },
                                    "like_count": resultSet.fieldByName('like_count'),
                                    "like_status": resultSet.fieldByName('like_status'),
                                    "is_liking": resultSet.fieldByName('is_liking')
                                }
                            }

                        messages.push(msg_obj);
                        resultSet.next();
                    }
                    resultSet.close();
                    return messages;
}


function plotPaginatedMessagesFromDB(messages, current_user_id, channel_name, targetDOM, history_type, new_offset) {
    if (history_type == "p2p") {
        for (var i = 0; i < messages.length; i++) {
            try
            {
                var message_obj = messages[i];
                console.log(message_obj);
                var date;
                var datetime;
                datetime = datify(message_obj);
                var unsentnote;
                unsentnote = "img/ExclamationMark.png"
                if (message_obj.sender) {
                    if (message_obj.sender.id == current_user_id){
                        // 
                        // chack if message contain attachment  
                        resetTime(); // reset previous time                    
                        if (message_obj.hasOwnProperty('attachment_type')) {
                            rightearlierAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,''); 
                        } else {

                            rightearlierMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,'',new_offset,i);
                            
                            safeMessage($('.'+ new_offset + '_' + i + '_message'));
                            Utility.linkifyMessage($('.'+ new_offset + '_' + i + '_message'));
                            emojifyMessage($('.'+ new_offset + '_' + i + '_message'));
                            stickerFry('.'+ new_offset + '_' + i + '_message');
                            // apply font style
                            if (message_obj.textformat != '') {
                                console.log(message_obj.textformat)
                                $(targetDOM + ' .chatRight:last .message').addClass('font-'+message_obj.textformat);
                            };                                 
                        }                                               
                    } else {
                        // 
                        // chack if message contain attachment                      
                        if (message_obj.hasOwnProperty('attachment_type')) {
                            leftearlierAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,'');
                        } else {
                            // 
                            // if message can be merged to last message
                            leftearlierMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,'',new_offset,i);
                            safeMessage($('.'+ new_offset + '_' + i + '_message'));
                            Utility.linkifyMessage($('.'+ new_offset + '_' + i + '_message'));
                            emojifyMessage($('.'+ new_offset + '_' + i + '_message'));
                            stickerFry('.'+ new_offset + '_' + i + '_message');                                                                 
                        }
                    }
                };
            }catch(e){}
        }
    } else if(history_type == "group") {
        for (var i = 0; i < messages.length; i++) {
            try
            {
                var message_obj = messages[i];
                console.log(message_obj);
                var date;
                var datetime;
                var unsentnote;
                unsentnote = "img/ExclamationMark.png"
                datetime = datify(message_obj);
                if (message_obj.sender) {
                    if (message_obj.sender.id == current_user_id){
                        // 
                        // chack if message contain attachment  
                        resetTime(); // reset previous time                    
                        if (message_obj.hasOwnProperty('attachment_type')) {
                           var icon ="";
                            if(message_obj.like_status == "0"){
                                 icon = "img/like-icon-grey-rev.png"
                            }else{
                                 icon = "img/like-icon-rev.png"
                            }
                            rightearlierAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);
                        } else {
                            var icon ="";
                            if(message_obj.like_status == "0"){
                                 icon = "img/like-icon-grey-rev.png"
                            }else{
                                 icon = "img/like-icon-rev.png"
                            }
                            rightearlierMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon,new_offset,i);
                            
                            safeMessage($('.'+ new_offset + '_' + i + '_message'));
                            Utility.linkifyMessage($('.'+ new_offset + '_' + i + '_message'));
                            emojifyMessage($('.'+ new_offset + '_' + i + '_message'));
                            stickerFry('.'+ new_offset + '_' + i + '_message');
                            // apply font style
                            if (message_obj.textformat != '') {
                                console.log(message_obj.textformat)
                                $(targetDOM + ' .chatRight:last .message').addClass('font-'+message_obj.textformat);
                            };                                 
                        }                                               
                    } else {
                        // 
                        // chack if message contain attachment                      
                        if (message_obj.hasOwnProperty('attachment_type')) {
                            var icon ="";
                            if(message_obj.like_status == "0"){
                                 icon = "img/like-icon-grey.png"
                            }else{
                                 icon = "img/like-icon.png"
                            }
                            leftearlierAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);
                        } else {
                            // 
                            // if message can be merged to last message
                            var icon ="";
                            if(message_obj.like_status == "0"){
                                 icon = "img/like-icon-grey.png"
                            }else{
                                 icon = "img/like-icon.png"
                            }

                            leftearlierMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon,new_offset,i);  
                            safeMessage($('.'+ new_offset + '_' + i + '_message'));
                            Utility.linkifyMessage($('.'+ new_offset + '_' + i + '_message'));
                            emojifyMessage($('.'+ new_offset + '_' + i + '_message'));
                            stickerFry('.'+ new_offset + '_' + i + '_message');                                                                 
                        }
                    }
                };
            }catch(e){}
        }
    } else if(history_type == "role") {
	    var current_userinfo = jQuery.parseJSON(localStorage["userinfo"]);
	    var suborg_id = current_userinfo.user_info.suborg;

		for (var i = 0; i < messages.length; i++) {
	        try
	        {
	            var message_obj = messages[i];
                var date;
                var datetime;
                var unsentnote;
                unsentnote = "img/ExclamationMark.png"
                datetime = datify(message_obj);
	            if ($.inArray(parseInt(suborg_id), eval(message_obj.allowed_suborg_ids)) !== -1){ // if user has authority to view message from sub organization
	                console.log(message_obj);
	                var icon ="";
	                if(message_obj.like_status == "1"){
	                    icon = "img/like-icon.png"
	                }else{
	                    icon = "img/like-icon-grey.png"
	                }

	                if (typeof message_obj.like_count === "undefined") {
	                    message_obj.like_count = "0";
	                }
	                
	                // if (message_obj.sender) {
	                    if (message_obj.sender.id == current_user_id){
                            resetTime(); // reset previous time
	                        if (message_obj.hasOwnProperty('attachment_type')) {
	                            rightearlierAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);
	                        }else{
                                rightearlierMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon,new_offset,i);   
                                
                                safeMessage($('.'+ new_offset + '_' + i + '_message'));
                                Utility.linkifyMessage($('.'+ new_offset + '_' + i + '_message'));
                                emojifyMessage($('.'+ new_offset + '_' + i + '_message'));
                                stickerFry('.'+ new_offset + '_' + i + '_message');
	                            // apply font style
	                            if (message_obj.textformat != '') {
	                                $(targetDOM + ' .chatRight:last .message').addClass('font-'+message_obj.textformat);
	                            };                                       
	                        }                                             
	                    } else {
	                        if (message_obj.hasOwnProperty('attachment_type')) {
	                            leftearlierAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);
	                         }else{
	                            // 
	                            // if message can be merged to last message

                                leftearlierMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon,new_offset,i);  
                                safeMessage($('.'+ new_offset + '_' + i + '_message'));
                                Utility.linkifyMessage($('.'+ new_offset + '_' + i + '_message'));
                                emojifyMessage($('.'+ new_offset + '_' + i + '_message'));
                                stickerFry('.'+ new_offset + '_' + i + '_message');                                      
	                         }   
	                         
	                    }              
	                // };  
	            }  
	        }catch(e){}        
	    }
    }

}