//
// function for background/wallpaper selection
function getWallpaperPhoto(source) {
  // Retrieve image file location from specified source
  

  navigator.camera.getPicture(onWallpaperPhotoURISuccess, onWallpaperFail, { quality: 50,
    destinationType: navigator.camera.DestinationType.FILE_URI,
    sourceType: source });
}

//
// user profile pic change

$(document).on('click','#user_profile_pic',function(){
  
  /*navigator.notification.confirm(
            'Choose picture source!', // message
            onprofilepicConfirm,                // callback to invoke with index of button pressed
            'Choose Picture!',              // title
            ['Camera','Library']      // buttonLabels
  );*/  
  var options = {
                title : "Select image file...",
                types : window.imagetypes,
                typesDescription : "Image files",
                path : "/"
            };

            var curwin = Ti.UI.currentWindow; 
            curwin.openFileChooserDialog( function(fileResponse) { 
                var file = Ti.Filesystem.getFile(fileResponse[0]); 
                desktopUploadProfilePic(file);
            },options);
});

var desktopUploadProfilePic = function(file){
            console.log("FILE");
            console.log(file);
            $.mobile.loading('show'); 
            var uploadStream = Ti.Filesystem.getFileStream(file);
        
            uploadStream.open(Ti.Filesystem.MODE_READ);
            content = uploadStream.read();
            uploadStream.close();
        
            console.log("CONTENT");    

            var xhr = Ti.Network.createHTTPClient();
            xhr.addEventListener(Ti.HTTP_DONE, function(){
                //alert('done');
                console.log("TI XHR DONE!");
                console.log(this.responseText);
                uploadUserPhoto(this.responseText);
                //text.innerHTML += "\n" + this.responseText;
            });
            xhr.addEventListener(Ti.HTTP_STATE_CHANGED, function(){
                //alert('changed');
                console.log("STATE CHANGED");
                console.log(this.responseText);
                //text.innerHTML += "\n" + this.responseText;
            });
            
            xhr.open('POST', $.apiUrl + "/ccc/desktp_file_upload");
            xhr.setRequestHeader("contentType", "multipart/form-data");
            xhr.send({uploadedfile: content,file: file});
}

// choose on source

function onprofilepicConfirm(button){
  if(button.toString() == "1"){
      navigator.camera.getPicture(onUserProfilePhotoURISuccess, onWallpaperFail, { quality: 50,
        destinationType: navigator.camera.DestinationType.FILE_URI,
        sourceType: navigator.camera.PictureSourceType.CAMERA 
      });
  }else if(button.toString() == "2"){
      navigator.camera.getPicture(onUserProfilePhotoURISuccess, onWallpaperFail, { quality: 50,
        destinationType: navigator.camera.DestinationType.FILE_URI,
        sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY 
      });
  }else{
      return false;
  }
}

// save image
function onUserProfilePhotoURISuccess(imageURI){
    // Upload the image to server using FileTransfer
    //
    $.mobile.loading('show'); 
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = imageURI.substr(imageURI.lastIndexOf('/')+1);
    options.mimeType    = "image/jpeg";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        imageURI, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var image_url = r.response.replace(/[\n]/g, "");
            uploadUserPhoto(image_url);
        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
            //$('#'+message_client_id).remove();
        }, 
        options
    );
}


// upload to server
function uploadUserPhoto(image_url){
  var session_token = localStorage["session_token"]
    $.ajax({
        url: $.apiUrl + "/ccc/api_v1/edituserimage",
        type: "POST",
        data: {
            user_image: image_url,
        },
        beforeSend: function(xhr) { 
            xhr.setRequestHeader('token', session_token);
        },
        success: function(json){
          $('#user_profile_pic').attr('src',json.user_image)
          $.mobile.loading('hide'); 
        },
        error: function (xhr, ajaxOptions, thrownError) {
            alert(xhr.status);
            alert(thrownError);
        }
    });
}

// clear wall paper
function clearWallpaper(){
	
	localStorage.removeItem("chat_wallpaper");
  $('#chat_bg_default').hide(); 	
  alert("Background image successfully reset to default");
}

// Called when a photo is successfully retrieved
//
function onWallpaperPhotoURISuccess(imageURI) {
  localStorage.setItem("chat_wallpaper", imageURI);
  $('#chat_bg_default').show();
  alert("Background image successfully set");
}

// Called if something bad happens.
//
function onWallpaperFail(message) {
  //alert('File selection failed because: ' + message);
  return false;
}